using IceCreamShopContracts.BindingModels;
using IceCreamShopContracts.BusinessLogicsContracts;
using IceCreamShopContracts.SearchModels;
using IceCreamShopContracts.StoragesContracts;
using IceCreamShopContracts.ViewModels;
using IceCreamShopDataModels.Enums;
using IceCreamShopDataModels.Models;
using Microsoft.Extensions.Logging;

namespace IceCreamShopBusinessLogic.BusinessLogics
{
    public class OrderLogic : IOrderLogic
    {
        private readonly ILogger _logger;

        private readonly IOrderStorage _orderStorage;

        private readonly IIceCreamStorage _iceCreamStorage;

        private readonly IShopStorage _shopStorage;

        private readonly IShopLogic _shopLogic;

        public OrderLogic(ILogger<OrderLogic> logger, IOrderStorage orderStorage, IIceCreamStorage iceCreamStorage, 
            IShopStorage shopStorage, IShopLogic shopLogic)
        {
            _logger = logger;
            _orderStorage = orderStorage;
            _iceCreamStorage = iceCreamStorage;
            _shopStorage = shopStorage;
            _shopLogic = shopLogic;
        }

        public bool CreateOrder(OrderBindingModel model)
        {
            CheckModel(model);
            if (model.Status != OrderStatus.Неизвестен)
            {
                _logger.LogWarning("Invalid order status");
                return false;
            }
            model.Status = OrderStatus.Принят;
            if (_orderStorage.Insert(model) == null)
            {
                _logger.LogWarning("Insert operation failed");
                return false;
            }
            return true;
        }

        public List<OrderViewModel>? ReadList(OrderSearchModel? model)
        {
            _logger.LogInformation("ReadList. OrderId: {Id}.", model?.Id);
            var list = model == null ? _orderStorage.GetFullList() : _orderStorage.GetFilteredList(model);
            if (list == null)
            {
                _logger.LogWarning("ReadList return null list");
                return null;
            }
            _logger.LogInformation("ReadList. Count: {Count}", list.Count);
            return list;
        }

        public bool TakeOrderInWork(OrderBindingModel model)
        {
            return ChangeStatus(model, OrderStatus.Выполняется);
        }

        public bool FinishOrder(OrderBindingModel model)
        {
            return ChangeStatus(model, OrderStatus.Готов);
        }

        public bool DeliveryOrder(OrderBindingModel model)
        {
            return ChangeStatus(model, OrderStatus.Выдан);
        }

        private void CheckModel(OrderBindingModel model, bool withParams = true)
        {
            if (model == null)
            {
                throw new ArgumentNullException(nameof(model));
            }
            if (!withParams)
            {
                return;
            }
            if (model.IceCreamId <= 0)
            {
                throw new ArgumentNullException("Некорректный идентификатор мороженого", nameof(model.IceCreamId));
            }
            if (model.ClientId <= 0)
            {
                throw new ArgumentNullException("Некорректный идентификатор клиента", nameof(model.ClientId));
            }
            if (model.Count <= 0)
            {
                throw new ArgumentNullException("В заказе должно быть хотя бы одно мороженое", nameof(model.Count));
            }
            if (model.Sum <= 0)
            {
                throw new ArgumentNullException("Стоимость заказа должна быть больше 0", nameof(model.Sum));
            }
            _logger.LogInformation("Order. Id: {Id}. Sum: {Sum}. IceCreamId: {IceCreamId}. IceCreamCount: {Count}", model.Id, model.Sum, 
                model.IceCreamId, model.Count);
        }

        private bool ChangeStatus(OrderBindingModel model, OrderStatus newStatus)
        {
            CheckModel(model, false);
            var order = _orderStorage.GetElement(new OrderSearchModel { Id = model.Id } );
            if (order == null)
            {
                _logger.LogWarning("Change status operation failed. Order not found");
                return false;
            }
            if (order.Status + 1 != newStatus)
            {
                _logger.LogWarning("Change status operation failed. Incorrect new status: {newStatus}. Current status: {currStatus}",
                    newStatus, order.Status);
                return false;
            }
            if (newStatus == OrderStatus.Выдан)
            {
                var iceCream = _iceCreamStorage.GetElement(new IceCreamSearchModel() { Id = order.IceCreamId });
                if (iceCream == null)
                {
                    _logger.LogWarning("Change status operation failed. Ice cream not found");
                    return false;
                }
                if (!DeliverIceCreams(iceCream, order.Count))
                {
                    _logger.LogWarning("Change status operation failed. Ice creams delivery operation failed");
                    return false;
                }
            }
            model.Status = newStatus;
            if (model.Status == OrderStatus.Готов)
            {
                model.DateImplement = DateTime.Now;
            } 
            else
            {
                model.DateImplement = order.DateImplement;
            }
            if (_orderStorage.Update(model) == null)
            {
                _logger.LogWarning("Change status operation failed");
                return false;
            }
            return true;
        }

        private bool DeliverIceCreams(IIceCreamModel iceCream, int count)
        {
            if (count <= 0)
            {
                _logger.LogWarning("Ice creams delivery operation failed. Ice cream count <= 0");
                return false;
            }

            var shopList = _shopStorage.GetFullList();
            int shopsCapacity = shopList.Sum(x => x.IceCreamsMaximum);
            int currentIceCreams = shopList.Select(x => x.ShopIceCreams.Sum(y => y.Value.Item2)).Sum();
            int freePlaces = shopsCapacity - currentIceCreams;

            if (freePlaces < count)
            {
                _logger.LogWarning("Ice creams delivery operation failed. No space for new ice creams");
                return false;
            }

            foreach (var shop in shopList)
            {
                freePlaces = shop.IceCreamsMaximum - shop.ShopIceCreams.Sum(x => x.Value.Item2);
                if (freePlaces == 0)
                {
                    continue;
                }
                if (freePlaces >= count)
                {
                    if (_shopLogic.MakeShipment(new() { Id = shop.Id }, iceCream, count))
                    {
                        count = 0;
                    }
                    else
                    {
                        _logger.LogWarning("Ice creams delivery operation failed");
                        return false;
                    }
                }
                else
                {
                    if (_shopLogic.MakeShipment(new() { Id = shop.Id }, iceCream, freePlaces))
                    {
                        count -= freePlaces;
                    }
                    else
                    {
                        _logger.LogWarning("Ice creams delivery operation failed");
                        return false;
                    }
                }
                if (count == 0)
                {
                    return true;
                }
            }
            return false;
        }
    }


}
